OpenJPH: ojph::stex::stex_file Struct Reference

OpenJPH Open-source implementation of JPEG2000 Part-15

Loading...
Searching...
No Matches
ojph::stex::stex_file Struct Reference

holds in memory j2k codestream together with other info More...

`#include <stream_expand_support.h>`

## Public Member Functions
| stex_file ()
| default constructor
void | init (frames_handler *parent, stex_file *next, j2k_frame_storer *storer, const char *name_template)
| call this function to initialize stex_file
void | notify_file_completion ()
| other threads can call this function to signal completion of processing.

## Public Attributes
ojph::mem_outfile | f
| holds in-memory j2k codestream
ui32 | time_stamp
| time stamp at which this file must be displayed
ui32 | last_seen_seq
| the last seen RTP sequence number
std::atomic_int | done
| saving is completed when 0 is reached
ui32 | frame_idx
| frame number in the sequence
frames_handler * | parent
| the object holding this frame
const char * | name_template
| name template for saved files
j2k_frame_storer * | storer
| stores a j2k frame using another thread
stex_file * | next
| used to create files chain

## Detailed Description

holds in memory j2k codestream together with other info

This objects holds a j2k codestream file. The codestream is identified by its timestamp. Once complete the file is pushed to saver.

File chains can be created using the "next" member variable.

This object is handled by frames_handler, and therefore, it does not have many functions. stex_file does not create any objects of its own.

The object also serves to pass information to the j2k_frame_storer, which is run by another thread

Definition at line 353 of file stream_expand_support.h.

## Constructor & Destructor Documentation

## ◆ stex_file()

ojph::stex::stex_file::stex_file | ( |  | ) |
| inline

default constructor

Definition at line 358 of file stream_expand_support.h.

References done, frame_idx, last_seen_seq, name_template, next, parent, storer, and time_stamp.

Referenced by init().

## Member Function Documentation

## ◆ init()

void ojph::stex::stex_file::init | ( | frames_handler * | parent,
|  | stex_file * | next,
|  | j2k_frame_storer * | storer,
|  | const char * | name_template )
| inline

call this function to initialize stex_file

It just copies parameters to the object.

Parameters

  parent | is a pointer to the object holding this file, which is frames_handler
  next | is used to chain files
  storer | this object is used to store j2k codestreams
  name_template | file name template to use for storeing files

Definition at line 381 of file stream_expand_support.h.

References name_template, next, parent, stex_file(), and storer.

## ◆ notify_file_completion()

void ojph::stex::stex_file::notify_file_completion | ( |  | ) |

other threads can call this function to signal completion of processing.

This function basically reduces "done", and when 0 is reached the function will let the parent know that there is a stex_file waiting removal.

Definition at line 241 of file stream_expand_support.cpp.

References done, and parent.

## Member Data Documentation

## ◆ done

std::atomic_int ojph::stex::stex_file::done

saving is completed when 0 is reached

Definition at line 404 of file stream_expand_support.h.

Referenced by ojph::stex::frames_handler::check_files_in_processing(), notify_file_completion(), and stex_file().

## ◆ f

ojph::mem_outfile ojph::stex::stex_file::f

holds in-memory j2k codestream

Definition at line 401 of file stream_expand_support.h.

## ◆ frame_idx

ui32 ojph::stex::stex_file::frame_idx

frame number in the sequence

Definition at line 405 of file stream_expand_support.h.

Referenced by ojph::stex::frames_handler::check_files_in_processing(), and stex_file().

## ◆ last_seen_seq

ui32 ojph::stex::stex_file::last_seen_seq

the last seen RTP sequence number

Definition at line 403 of file stream_expand_support.h.

Referenced by ojph::stex::frames_handler::check_files_in_processing(), and stex_file().

## ◆ name_template

const char* ojph::stex::stex_file::name_template

name template for saved files

Definition at line 408 of file stream_expand_support.h.

Referenced by init(), and stex_file().

## ◆ next

stex_file* ojph::stex::stex_file::next

used to create files chain

Definition at line 411 of file stream_expand_support.h.

Referenced by ojph::stex::frames_handler::check_files_in_processing(), init(), and stex_file().

## ◆ parent

frames_handler* ojph::stex::stex_file::parent

the object holding this frame

Definition at line 406 of file stream_expand_support.h.

Referenced by init(), notify_file_completion(), and stex_file().

## ◆ storer

j2k_frame_storer* ojph::stex::stex_file::storer

stores a j2k frame using another thread

Definition at line 409 of file stream_expand_support.h.

Referenced by init(), and stex_file().

## ◆ time_stamp

ui32 ojph::stex::stex_file::time_stamp

time stamp at which this file must be displayed

Definition at line 402 of file stream_expand_support.h.

Referenced by ojph::stex::frames_handler::check_files_in_processing(), and stex_file().

The documentation for this struct was generated from the following files:

- /build/openjph/src/OpenJPH/src/apps/ojph_stream_expand/stream_expand_support.h
- /build/openjph/src/OpenJPH/src/apps/ojph_stream_expand/stream_expand_support.cpp